<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:14 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>ExtensionAware (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="ExtensionAware (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/plugins/DeferredConfigurable.html" title="annotation in org.gradle.api.plugins"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/plugins/ExtensionContainer.html" title="interface in org.gradle.api.plugins"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/plugins/ExtensionAware.html" target="_top">Frames</a></li>
<li><a href="ExtensionAware.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.api.plugins</div>
<h2 title="Interface ExtensionAware" class="title">Interface ExtensionAware</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Known Subinterfaces:</dt>
<dd><a href="../../../../org/gradle/nativeplatform/tasks/ObjectFilesToBinary.html" title="interface in org.gradle.nativeplatform.tasks">ObjectFilesToBinary</a>, <a href="../../../../org/gradle/api/Project.html" title="interface in org.gradle.api">Project</a>, <a href="../../../../org/gradle/api/Task.html" title="interface in org.gradle.api">Task</a></dd>
</dl>
<dl>
<dt>All Known Implementing Classes:</dt>
<dd><a href="../../../../org/gradle/api/tasks/bundling/AbstractArchiveTask.html" title="class in org.gradle.api.tasks.bundling">AbstractArchiveTask</a>, <a href="../../../../org/gradle/api/tasks/compile/AbstractCompile.html" title="class in org.gradle.api.tasks.compile">AbstractCompile</a>, <a href="../../../../org/gradle/api/tasks/AbstractCopyTask.html" title="class in org.gradle.api.tasks">AbstractCopyTask</a>, <a href="../../../../org/gradle/api/tasks/diagnostics/AbstractDependencyReportTask.html" title="class in org.gradle.api.tasks.diagnostics">AbstractDependencyReportTask</a>, <a href="../../../../org/gradle/api/tasks/AbstractExecTask.html" title="class in org.gradle.api.tasks">AbstractExecTask</a>, <a href="../../../../org/gradle/nativeplatform/tasks/AbstractLinkTask.html" title="class in org.gradle.nativeplatform.tasks">AbstractLinkTask</a>, <a href="../../../../org/gradle/language/nativeplatform/tasks/AbstractNativeCompileTask.html" title="class in org.gradle.language.nativeplatform.tasks">AbstractNativeCompileTask</a>, <a href="../../../../org/gradle/language/nativeplatform/tasks/AbstractNativePCHCompileTask.html" title="class in org.gradle.language.nativeplatform.tasks">AbstractNativePCHCompileTask</a>, <a href="../../../../org/gradle/language/nativeplatform/tasks/AbstractNativeSourceCompileTask.html" title="class in org.gradle.language.nativeplatform.tasks">AbstractNativeSourceCompileTask</a>, <a href="../../../../org/gradle/api/publish/maven/tasks/AbstractPublishToMaven.html" title="class in org.gradle.api.publish.maven.tasks">AbstractPublishToMaven</a>, <a href="../../../../org/gradle/api/tasks/diagnostics/AbstractReportTask.html" title="class in org.gradle.api.tasks.diagnostics">AbstractReportTask</a>, <a href="../../../../org/gradle/language/scala/tasks/AbstractScalaCompile.html" title="class in org.gradle.language.scala.tasks">AbstractScalaCompile</a>, org.gradle.api.internal.AbstractTask, <a href="../../../../org/gradle/api/plugins/antlr/AntlrTask.html" title="class in org.gradle.api.plugins.antlr">AntlrTask</a>, <a href="../../../../org/gradle/api/tasks/ant/AntTarget.html" title="class in org.gradle.api.tasks.ant">AntTarget</a>, <a href="../../../../org/gradle/jvm/tasks/api/ApiJar.html" title="class in org.gradle.jvm.tasks.api">ApiJar</a>, <a href="../../../../org/gradle/language/assembler/tasks/Assemble.html" title="class in org.gradle.language.assembler.tasks">Assemble</a>, <a href="../../../../org/gradle/plugins/javascript/envjs/browser/BrowserEvaluate.html" title="class in org.gradle.plugins.javascript.envjs.browser">BrowserEvaluate</a>, <a href="../../../../org/gradle/api/tasks/diagnostics/BuildEnvironmentReportTask.html" title="class in org.gradle.api.tasks.diagnostics">BuildEnvironmentReportTask</a>, <a href="../../../../org/gradle/language/c/tasks/CCompile.html" title="class in org.gradle.language.c.tasks">CCompile</a>, <a href="../../../../org/gradle/api/plugins/quality/Checkstyle.html" title="class in org.gradle.api.plugins.quality">Checkstyle</a>, <a href="../../../../org/gradle/api/plugins/quality/CodeNarc.html" title="class in org.gradle.api.plugins.quality">CodeNarc</a>, <a href="../../../../org/gradle/plugins/javascript/coffeescript/CoffeeScriptCompile.html" title="class in org.gradle.plugins.javascript.coffeescript">CoffeeScriptCompile</a>, <a href="../../../../org/gradle/api/plugins/buildcomparison/gradle/CompareGradleBuilds.html" title="class in org.gradle.api.plugins.buildcomparison.gradle">CompareGradleBuilds</a>, <a href="../../../../org/gradle/api/reporting/components/ComponentReport.html" title="class in org.gradle.api.reporting.components">ComponentReport</a>, org.gradle.api.internal.ConventionTask, <a href="../../../../org/gradle/api/tasks/Copy.html" title="class in org.gradle.api.tasks">Copy</a>, <a href="../../../../org/gradle/language/cpp/tasks/CppCompile.html" title="class in org.gradle.language.cpp.tasks">CppCompile</a>, <a href="../../../../org/gradle/language/cpp/tasks/CppPreCompiledHeaderCompile.html" title="class in org.gradle.language.cpp.tasks">CppPreCompiledHeaderCompile</a>, <a href="../../../../org/gradle/language/c/tasks/CPreCompiledHeaderCompile.html" title="class in org.gradle.language.c.tasks">CPreCompiledHeaderCompile</a>, <a href="../../../../org/gradle/jvm/application/tasks/CreateStartScripts.html" title="class in org.gradle.jvm.application.tasks">CreateStartScripts</a>, <a href="../../../../org/gradle/api/tasks/application/CreateStartScripts.html" title="class in org.gradle.api.tasks.application">CreateStartScripts</a>, <a href="../../../../org/gradle/nativeplatform/tasks/CreateStaticLibrary.html" title="class in org.gradle.nativeplatform.tasks">CreateStaticLibrary</a>, <a href="../../../../org/gradle/nativeplatform/test/xctest/tasks/CreateXcTestBundle.html" title="class in org.gradle.nativeplatform.test.xctest.tasks">CreateXcTestBundle</a>, <a href="../../../../org/gradle/api/DefaultTask.html" title="class in org.gradle.api">DefaultTask</a>, <a href="../../../../org/gradle/api/tasks/Delete.html" title="class in org.gradle.api.tasks">Delete</a>, <a href="../../../../org/gradle/api/tasks/diagnostics/DependencyInsightReportTask.html" title="class in org.gradle.api.tasks.diagnostics">DependencyInsightReportTask</a>, <a href="../../../../org/gradle/api/tasks/diagnostics/DependencyReportTask.html" title="class in org.gradle.api.tasks.diagnostics">DependencyReportTask</a>, <a href="../../../../org/gradle/api/reporting/dependents/DependentComponentsReport.html" title="class in org.gradle.api.reporting.dependents">DependentComponentsReport</a>, <a href="../../../../org/gradle/plugins/ear/Ear.html" title="class in org.gradle.plugins.ear">Ear</a>, <a href="../../../../org/gradle/api/tasks/Exec.html" title="class in org.gradle.api.tasks">Exec</a>, <a href="../../../../org/gradle/api/plugins/quality/FindBugs.html" title="class in org.gradle.api.plugins.quality">FindBugs</a>, <a href="../../../../org/gradle/api/reporting/GenerateBuildDashboard.html" title="class in org.gradle.api.reporting">GenerateBuildDashboard</a>, <a href="../../../../org/gradle/nativeplatform/test/cunit/tasks/GenerateCUnitLauncher.html" title="class in org.gradle.nativeplatform.test.cunit.tasks">GenerateCUnitLauncher</a>, <a href="../../../../org/gradle/plugins/ide/eclipse/GenerateEclipseClasspath.html" title="class in org.gradle.plugins.ide.eclipse">GenerateEclipseClasspath</a>, <a href="../../../../org/gradle/plugins/ide/eclipse/GenerateEclipseJdt.html" title="class in org.gradle.plugins.ide.eclipse">GenerateEclipseJdt</a>, <a href="../../../../org/gradle/plugins/ide/eclipse/GenerateEclipseProject.html" title="class in org.gradle.plugins.ide.eclipse">GenerateEclipseProject</a>, <a href="../../../../org/gradle/plugins/ide/eclipse/GenerateEclipseWtpComponent.html" title="class in org.gradle.plugins.ide.eclipse">GenerateEclipseWtpComponent</a>, <a href="../../../../org/gradle/plugins/ide/eclipse/GenerateEclipseWtpFacet.html" title="class in org.gradle.plugins.ide.eclipse">GenerateEclipseWtpFacet</a>, <a href="../../../../org/gradle/ide/visualstudio/tasks/GenerateFiltersFileTask.html" title="class in org.gradle.ide.visualstudio.tasks">GenerateFiltersFileTask</a>, <a href="../../../../org/gradle/plugins/ide/idea/GenerateIdeaModule.html" title="class in org.gradle.plugins.ide.idea">GenerateIdeaModule</a>, <a href="../../../../org/gradle/plugins/ide/idea/GenerateIdeaProject.html" title="class in org.gradle.plugins.ide.idea">GenerateIdeaProject</a>, <a href="../../../../org/gradle/plugins/ide/idea/GenerateIdeaWorkspace.html" title="class in org.gradle.plugins.ide.idea">GenerateIdeaWorkspace</a>, <a href="../../../../org/gradle/api/publish/ivy/tasks/GenerateIvyDescriptor.html" title="class in org.gradle.api.publish.ivy.tasks">GenerateIvyDescriptor</a>, <a href="../../../../org/gradle/api/publish/maven/tasks/GenerateMavenPom.html" title="class in org.gradle.api.publish.maven.tasks">GenerateMavenPom</a>, <a href="../../../../org/gradle/plugin/devel/tasks/GeneratePluginDescriptors.html" title="class in org.gradle.plugin.devel.tasks">GeneratePluginDescriptors</a>, <a href="../../../../org/gradle/ide/visualstudio/tasks/GenerateProjectFileTask.html" title="class in org.gradle.ide.visualstudio.tasks">GenerateProjectFileTask</a>, <a href="../../../../org/gradle/ide/xcode/tasks/GenerateSchemeFileTask.html" title="class in org.gradle.ide.xcode.tasks">GenerateSchemeFileTask</a>, <a href="../../../../org/gradle/ide/visualstudio/tasks/GenerateSolutionFileTask.html" title="class in org.gradle.ide.visualstudio.tasks">GenerateSolutionFileTask</a>, <a href="../../../../org/gradle/ide/xcode/tasks/GenerateWorkspaceSettingsFileTask.html" title="class in org.gradle.ide.xcode.tasks">GenerateWorkspaceSettingsFileTask</a>, <a href="../../../../org/gradle/ide/xcode/tasks/GenerateXcodeProjectFileTask.html" title="class in org.gradle.ide.xcode.tasks">GenerateXcodeProjectFileTask</a>, <a href="../../../../org/gradle/ide/xcode/tasks/GenerateXcodeWorkspaceFileTask.html" title="class in org.gradle.ide.xcode.tasks">GenerateXcodeWorkspaceFileTask</a>, <a href="../../../../org/gradle/plugins/ide/api/GeneratorTask.html" title="class in org.gradle.plugins.ide.api">GeneratorTask</a>, <a href="../../../../org/gradle/api/tasks/GradleBuild.html" title="class in org.gradle.api.tasks">GradleBuild</a>, <a href="../../../../org/gradle/api/tasks/compile/GroovyCompile.html" title="class in org.gradle.api.tasks.compile">GroovyCompile</a>, <a href="../../../../org/gradle/api/tasks/javadoc/Groovydoc.html" title="class in org.gradle.api.tasks.javadoc">Groovydoc</a>, <a href="../../../../org/gradle/api/reporting/dependencies/HtmlDependencyReportTask.html" title="class in org.gradle.api.reporting.dependencies">HtmlDependencyReportTask</a>, <a href="../../../../org/gradle/buildinit/tasks/InitBuild.html" title="class in org.gradle.buildinit.tasks">InitBuild</a>, <a href="../../../../org/gradle/nativeplatform/tasks/InstallExecutable.html" title="class in org.gradle.nativeplatform.tasks">InstallExecutable</a>, <a href="../../../../org/gradle/testing/jacoco/tasks/JacocoBase.html" title="class in org.gradle.testing.jacoco.tasks">JacocoBase</a>, <a href="../../../../org/gradle/testing/jacoco/tasks/JacocoCoverageVerification.html" title="class in org.gradle.testing.jacoco.tasks">JacocoCoverageVerification</a>, <a href="../../../../org/gradle/testing/jacoco/tasks/JacocoMerge.html" title="class in org.gradle.testing.jacoco.tasks">JacocoMerge</a>, <a href="../../../../org/gradle/testing/jacoco/tasks/JacocoReport.html" title="class in org.gradle.testing.jacoco.tasks">JacocoReport</a>, <a href="../../../../org/gradle/testing/jacoco/tasks/JacocoReportBase.html" title="class in org.gradle.testing.jacoco.tasks">JacocoReportBase</a>, <a href="../../../../org/gradle/jvm/tasks/Jar.html" title="class in org.gradle.jvm.tasks">Jar</a>, <a href="../../../../org/gradle/api/tasks/bundling/Jar.html" title="class in org.gradle.api.tasks.bundling">Jar</a>, <a href="../../../../org/gradle/api/tasks/compile/JavaCompile.html" title="class in org.gradle.api.tasks.compile">JavaCompile</a>, <a href="../../../../org/gradle/api/tasks/javadoc/Javadoc.html" title="class in org.gradle.api.tasks.javadoc">Javadoc</a>, <a href="../../../../org/gradle/api/tasks/JavaExec.html" title="class in org.gradle.api.tasks">JavaExec</a>, <a href="../../../../org/gradle/play/tasks/JavaScriptMinify.html" title="class in org.gradle.play.tasks">JavaScriptMinify</a>, <a href="../../../../org/gradle/api/plugins/quality/JDepend.html" title="class in org.gradle.api.plugins.quality">JDepend</a>, <a href="../../../../org/gradle/plugins/javascript/jshint/JsHint.html" title="class in org.gradle.plugins.javascript.jshint">JsHint</a>, <a href="../../../../org/gradle/nativeplatform/tasks/LinkExecutable.html" title="class in org.gradle.nativeplatform.tasks">LinkExecutable</a>, <a href="../../../../org/gradle/nativeplatform/tasks/LinkSharedLibrary.html" title="class in org.gradle.nativeplatform.tasks">LinkSharedLibrary</a>, <a href="../../../../org/gradle/api/reporting/model/ModelReport.html" title="class in org.gradle.api.reporting.model">ModelReport</a>, <a href="../../../../org/gradle/language/objectivec/tasks/ObjectiveCCompile.html" title="class in org.gradle.language.objectivec.tasks">ObjectiveCCompile</a>, <a href="../../../../org/gradle/language/objectivecpp/tasks/ObjectiveCppCompile.html" title="class in org.gradle.language.objectivecpp.tasks">ObjectiveCppCompile</a>, <a href="../../../../org/gradle/language/objectivecpp/tasks/ObjectiveCppPreCompiledHeaderCompile.html" title="class in org.gradle.language.objectivecpp.tasks">ObjectiveCppPreCompiledHeaderCompile</a>, <a href="../../../../org/gradle/language/objectivec/tasks/ObjectiveCPreCompiledHeaderCompile.html" title="class in org.gradle.language.objectivec.tasks">ObjectiveCPreCompiledHeaderCompile</a>, <a href="../../../../org/gradle/language/java/tasks/PlatformJavaCompile.html" title="class in org.gradle.language.java.tasks">PlatformJavaCompile</a>, <a href="../../../../org/gradle/language/scala/tasks/PlatformScalaCompile.html" title="class in org.gradle.language.scala.tasks">PlatformScalaCompile</a>, <a href="../../../../org/gradle/play/tasks/PlayCoffeeScriptCompile.html" title="class in org.gradle.play.tasks">PlayCoffeeScriptCompile</a>, <a href="../../../../org/gradle/play/tasks/PlayRun.html" title="class in org.gradle.play.tasks">PlayRun</a>, <a href="../../../../org/gradle/plugin/devel/tasks/PluginUnderTestMetadata.html" title="class in org.gradle.plugin.devel.tasks">PluginUnderTestMetadata</a>, <a href="../../../../org/gradle/api/plugins/quality/Pmd.html" title="class in org.gradle.api.plugins.quality">Pmd</a>, <a href="../../../../org/gradle/nativeplatform/tasks/PrefixHeaderFileGenerateTask.html" title="class in org.gradle.nativeplatform.tasks">PrefixHeaderFileGenerateTask</a>, <a href="../../../../org/gradle/language/jvm/tasks/ProcessResources.html" title="class in org.gradle.language.jvm.tasks">ProcessResources</a>, <a href="../../../../org/gradle/api/tasks/diagnostics/ProjectReportTask.html" title="class in org.gradle.api.tasks.diagnostics">ProjectReportTask</a>, <a href="../../../../org/gradle/plugins/ide/api/PropertiesGeneratorTask.html" title="class in org.gradle.plugins.ide.api">PropertiesGeneratorTask</a>, <a href="../../../../org/gradle/plugins/ide/api/PropertyListGeneratorTask.html" title="class in org.gradle.plugins.ide.api">PropertyListGeneratorTask</a>, <a href="../../../../org/gradle/api/tasks/diagnostics/PropertyReportTask.html" title="class in org.gradle.api.tasks.diagnostics">PropertyReportTask</a>, <a href="../../../../org/gradle/api/publish/ivy/tasks/PublishToIvyRepository.html" title="class in org.gradle.api.publish.ivy.tasks">PublishToIvyRepository</a>, <a href="../../../../org/gradle/api/publish/maven/tasks/PublishToMavenLocal.html" title="class in org.gradle.api.publish.maven.tasks">PublishToMavenLocal</a>, <a href="../../../../org/gradle/api/publish/maven/tasks/PublishToMavenRepository.html" title="class in org.gradle.api.publish.maven.tasks">PublishToMavenRepository</a>, <a href="../../../../org/gradle/plugins/javascript/rhino/RhinoShellExec.html" title="class in org.gradle.plugins.javascript.rhino">RhinoShellExec</a>, <a href="../../../../org/gradle/play/tasks/RoutesCompile.html" title="class in org.gradle.play.tasks">RoutesCompile</a>, <a href="../../../../org/gradle/nativeplatform/test/tasks/RunTestExecutable.html" title="class in org.gradle.nativeplatform.test.tasks">RunTestExecutable</a>, <a href="../../../../org/gradle/api/tasks/scala/ScalaCompile.html" title="class in org.gradle.api.tasks.scala">ScalaCompile</a>, <a href="../../../../org/gradle/api/tasks/scala/ScalaDoc.html" title="class in org.gradle.api.tasks.scala">ScalaDoc</a>, <a href="../../../../org/gradle/plugins/signing/Sign.html" title="class in org.gradle.plugins.signing">Sign</a>, <a href="../../../../org/gradle/api/tasks/SourceTask.html" title="class in org.gradle.api.tasks">SourceTask</a>, <a href="../../../../org/gradle/language/swift/tasks/SwiftCompile.html" title="class in org.gradle.language.swift.tasks">SwiftCompile</a>, <a href="../../../../org/gradle/api/tasks/Sync.html" title="class in org.gradle.api.tasks">Sync</a>, <a href="../../../../org/gradle/api/tasks/bundling/Tar.html" title="class in org.gradle.api.tasks.bundling">Tar</a>, <a href="../../../../org/gradle/api/tasks/diagnostics/TaskReportTask.html" title="class in org.gradle.api.tasks.diagnostics">TaskReportTask</a>, <a href="../../../../org/gradle/api/tasks/testing/Test.html" title="class in org.gradle.api.tasks.testing">Test</a>, <a href="../../../../org/gradle/api/tasks/testing/TestReport.html" title="class in org.gradle.api.tasks.testing">TestReport</a>, <a href="../../../../org/gradle/play/tasks/TwirlCompile.html" title="class in org.gradle.play.tasks">TwirlCompile</a>, <a href="../../../../org/gradle/api/tasks/Upload.html" title="class in org.gradle.api.tasks">Upload</a>, <a href="../../../../org/gradle/plugin/devel/tasks/ValidateTaskProperties.html" title="class in org.gradle.plugin.devel.tasks">ValidateTaskProperties</a>, <a href="../../../../org/gradle/api/tasks/bundling/War.html" title="class in org.gradle.api.tasks.bundling">War</a>, <a href="../../../../org/gradle/language/rc/tasks/WindowsResourceCompile.html" title="class in org.gradle.language.rc.tasks">WindowsResourceCompile</a>, <a href="../../../../org/gradle/api/tasks/wrapper/Wrapper.html" title="class in org.gradle.api.tasks.wrapper">Wrapper</a>, <a href="../../../../org/gradle/api/tasks/WriteProperties.html" title="class in org.gradle.api.tasks">WriteProperties</a>, <a href="../../../../org/gradle/nativeplatform/test/xctest/tasks/XcTest.html" title="class in org.gradle.nativeplatform.test.xctest.tasks">XcTest</a>, <a href="../../../../org/gradle/plugins/ide/api/XmlGeneratorTask.html" title="class in org.gradle.plugins.ide.api">XmlGeneratorTask</a>, <a href="../../../../org/gradle/api/tasks/bundling/Zip.html" title="class in org.gradle.api.tasks.bundling">Zip</a></dd>
</dl>
<hr>
<br>
<pre>public interface <span class="strong">ExtensionAware</span></pre>
<div class="block">Objects that can be extended at runtime with other objects.

 <pre class='autoTested'>
 // Extensions are just plain objects, there is no interface/type
 class MyExtension {
   String foo

   MyExtension(String foo) {
     this.foo = foo
   }
 }

 // Add new extensions via the extension container
 project.extensions.create('custom', MyExtension, "bar")
 //                       («name»,   «type»,       «constructor args», …)

 // extensions appear as properties on the target object by the given name
 assert project.custom instanceof MyExtension
 assert project.custom.foo == "bar"

 // also via a namespace method
 project.custom {
   assert foo == "bar"
   foo = "other"
 }
 assert project.custom.foo == "other"

 // Extensions added with the extension container's create method are themselves extensible
 assert project.custom instanceof ExtensionAware
 project.custom.extensions.create("nested", MyExtension, "baz")
 assert project.custom.nested.foo == "baz"

 // All extension aware objects have a special “ext” extension of type ExtraPropertiesExtension
 assert project.hasProperty("myProperty") == false
 project.ext.myProperty = "myValue"

 // Properties added to the “ext” extension are promoted to the owning object
 assert project.myProperty == "myValue"
 </pre>

 Many Gradle objects are extension aware. This includes; projects, tasks, configurations, dependencies etc.
 <p>
 For more on adding &amp; creating extensions, see <a href="../../../../org/gradle/api/plugins/ExtensionContainer.html" title="interface in org.gradle.api.plugins"><code>ExtensionContainer</code></a>.
 <p>
 For more on extra properties, see <a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.html" title="interface in org.gradle.api.plugins"><code>ExtraPropertiesExtension</code></a>.
 <p>
 An <code>ExtensionAware</code> object has several 'scopes' that Gradle searches for properties. These scopes are:</p>

 <ul>
 <li>The object itself. This scope includes any property getters and setters declared by the
 implementation class. The properties of this scope are readable or writable depending on the presence
 of the corresponding getter or setter method.</li>

 <li>Groovy Meta-programming methods implemented by the object's class, like <code>propertyMissing()</code>. Care must be taken by plugin authors to
 ensure <code>propertyMissing()</code> is implemented such that if a property is not found a MissingPropertyException(String, Class) exception is thrown.
 If <code>propertyMissing()</code> always returns a value for any property, <em>Gradle will not search the rest of the scopes below.</em></li>

 <li>The <em>extra</em> properties of the object.  Each object maintains a map of extra properties, which
 can contain any arbitrary name -&gt; value pair.  Once defined, the properties of this scope are readable and writable.</li>

 <li>The <em>extensions</em> added to the object by plugins. Each extension is available as a read-only property with the same name as the extension.</li>
 </ul></div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="../../../../org/gradle/api/plugins/ExtensionContainer.html" title="interface in org.gradle.api.plugins">ExtensionContainer</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/plugins/ExtensionAware.html#getExtensions()">getExtensions</a></strong>()</code>
<div class="block">The container of extensions.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="getExtensions()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getExtensions</h4>
<pre><a href="../../../../org/gradle/api/plugins/ExtensionContainer.html" title="interface in org.gradle.api.plugins">ExtensionContainer</a>&nbsp;getExtensions()</pre>
<div class="block">The container of extensions.</div>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/plugins/DeferredConfigurable.html" title="annotation in org.gradle.api.plugins"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/plugins/ExtensionContainer.html" title="interface in org.gradle.api.plugins"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/plugins/ExtensionAware.html" target="_top">Frames</a></li>
<li><a href="ExtensionAware.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
